Index: trunk/kernel/fs/sysfs/sysfs_context.c
===================================================================
--- trunk/kernel/fs/sysfs/sysfs_context.c	(revision 1)
+++ trunk/kernel/fs/sysfs/sysfs_context.c	(revision 1)
@@ -0,0 +1,89 @@
+ /*
+ * sysfs/sysfs_context.c - sysfs context related operations
+ *
+ * Copyright (c) 2008,2009,2010,2011,2012 Ghassan Almaless
+ * Copyright (c) 2011,2012 UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-kernel.
+ *
+ * ALMOS-kernel is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-kernel is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-kernel; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#include <device.h>
+#include <driver.h>
+#include <kmem.h>
+#include <string.h>
+#include <vfs.h>
+#include <errno.h>
+#include <metafs.h>
+
+#include <sysfs.h>
+#include <sysfs-private.h>
+
+sysfs_entry_t sysfs_root_entry;
+
+VFS_CREATE_CONTEXT(sysfs_create_context)
+{ 
+	context->ctx_type    = FS_TYPE_SYSFS;
+	VFS_SET(context->ctx_flags, VFS_FS_LOCAL);
+	context->ctx_op      = (struct vfs_context_op_s *) &sysfs_ctx_op;
+	context->ctx_inode_op = (struct vfs_inode_op_s *) &sysfs_i_op;
+	context->ctx_file_op = (struct vfs_file_op_s *) &sysfs_f_op;
+	return 0;
+}
+
+VFS_DESTROY_CONTEXT(sysfs_destroy_context)
+{
+	return 0;
+}
+
+VFS_READ_ROOT(sysfs_read_root)
+{ 
+	struct sysfs_node_s *info;
+  
+	root->i_links = 1;
+	root->i_size  = 0;
+	root->i_attr  = VFS_DIR;
+	root->i_number = vfs_inum_new(context);
+
+	//info has been allocated by sysfs_init
+	info         = root->i_pv;
+	info->node   = &sysfs_root_entry.node;
+  
+	return 0;
+}
+
+VFS_REPLI_ROOT(sysfs_repli_root)
+{ 
+	struct sysfs_node_s *info;
+
+	info         = root->i_pv;
+	info->node   = &sysfs_root_entry.node;
+  
+	return 0;
+}
+
+VFS_WRITE_ROOT(sysfs_write_root)
+{
+	return 0;
+}
+
+const struct vfs_context_op_s sysfs_ctx_op = 
+{
+	.create     = sysfs_create_context,
+	.destroy    = sysfs_destroy_context,
+	.read_root  = sysfs_read_root,
+	.repli_root = sysfs_repli_root,
+	.write_root = sysfs_write_root
+};
Index: trunk/kernel/fs/sysfs/sysfs_file.c
===================================================================
--- trunk/kernel/fs/sysfs/sysfs_file.c	(revision 1)
+++ trunk/kernel/fs/sysfs/sysfs_file.c	(revision 1)
@@ -0,0 +1,186 @@
+/*
+ * sysfs/sysfs_file.c - sysfs file related operations
+ *
+ * Copyright (c) 2008,2009,2010,2011,2012 Ghassan Almaless
+ * Copyright (c) 2011,2012 UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-kernel.
+ *
+ * ALMOS-kernel is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-kernel is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-kernel; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#include <config.h>
+#include <device.h>
+#include <driver.h>
+#include <kmem.h>
+#include <kdmsg.h>
+#include <string.h>
+#include <vfs.h>
+#include <errno.h>
+#include <metafs.h>
+#include <thread.h>
+#include <task.h>
+
+#include <sysfs.h>
+#include <sysfs-private.h>
+
+KMEM_OBJATTR_INIT(sysfs_kmem_file_init)
+{
+	attr->type   = KMEM_SYSFS_FILE;
+	attr->name   = "KCM SysFs File";
+	attr->size   = sizeof(struct sysfs_file_s);
+	attr->aligne = 0;
+	attr->min    = CONFIG_SYSFS_FILE_MIN;
+	attr->max    = CONFIG_SYSFS_FILE_MAX;
+	attr->ctor   = NULL;
+	attr->dtor   = NULL;
+	return 0;
+}
+
+
+VFS_OPEN_FILE(sysfs_open)
+{
+	register struct sysfs_file_s *f_info;
+	register struct sysfs_node_s *n_info;
+	register sysfs_entry_t *entry;
+	kmem_req_t req;
+
+	n_info = file->fr_inode->i_pv;
+	f_info = file->fr_pv;
+  
+	if((file->fr_pv == NULL))
+	{
+		req.type  = KMEM_SYSFS_FILE;
+		req.size  = sizeof(*f_info);
+		req.flags = AF_KERNEL;
+
+		f_info    = kmem_alloc(&req);
+	}
+
+	if(f_info == NULL)
+		return ENOMEM;
+
+	f_info->node          = n_info->node;
+	entry                 = metafs_container(f_info->node, sysfs_entry_t, node);
+	f_info->entry         = entry;
+	f_info->current_index = 0;
+	file->fr_pv            = f_info;
+  
+	if(file->fr_inode->i_attr & VFS_DIR)
+	{
+		metafs_iter_init(f_info->node, &f_info->iter);
+		return 0;
+	}
+  
+	if(entry->op.open)
+		return entry->op.open(entry, &f_info->rq, &file->fr_offset);
+  
+	return 0;
+}
+
+VFS_READ_FILE(sysfs_read)
+{
+	register struct sysfs_file_s *info;
+	register uint_t size;
+	register error_t err;
+
+	//TODO: handle the case where the this fs is
+	//accessed remotly  
+	assert(file->f_inode.cid == current_cid);
+
+	info = file->f_remote->fr_pv;
+
+	if(info->entry->op.read == NULL)
+		return ENOSYS;
+  
+	if(info->current_index == 0)
+	{
+		if((err = info->entry->op.read(info->entry, &info->rq, &file->f_remote->fr_offset)))
+		{
+			printk(INFO, "INFO: sysfs_read: error %d\n", err);
+			return err;
+		}
+	}
+
+	size = buffer->size;
+	if(size > info->rq.count)
+		size = info->rq.count;
+   
+	buffer->scpy_to_buff(buffer, &info->rq.buffer[info->current_index], size);
+  
+	info->rq.count     -= size;
+	info->current_index = (info->rq.count) ? info->current_index + size : 0;
+
+	return size;
+}
+
+VFS_WRITE_FILE(sysfs_write)
+{
+	return ENOTSUPPORTED;
+}
+
+VFS_LSEEK_FILE(sysfs_lseek)
+{
+	return ENOTSUPPORTED;
+}
+
+VFS_CLOSE_FILE(sysfs_close)
+{
+	return 0;
+}
+
+VFS_RELEASE_FILE(sysfs_release)
+{  
+	kmem_req_t req;
+  
+	if(file->fr_pv == NULL)
+		return 0;
+  
+	req.type   = KMEM_SYSFS_FILE;
+	req.ptr    = file->fr_pv;
+	kmem_free(&req);
+	file->fr_pv = NULL;
+
+	return 0;
+}
+
+VFS_READ_DIR(sysfs_readdir)
+{
+	register struct sysfs_file_s *info;
+	register struct metafs_s *current;
+  
+	info = file->fr_pv;
+
+	if((current = metafs_lookup_next(info->node, &info->iter)) == NULL)
+		return EEODIR;
+
+	dirent->u_attr = (metafs_hasChild(current)) ? VFS_DIR : 0;
+	strcpy((char*)dirent->u_name, metafs_get_name(current));
+  
+	//FIXME: better inode number
+	dirent->u_ino = (uint_t) current;
+
+	return 0;
+}
+
+const struct vfs_file_op_s sysfs_f_op = 
+{
+	.open    = sysfs_open,
+	.read    = sysfs_read,
+	.write   = sysfs_write,
+	.lseek   = sysfs_lseek,
+	.readdir = sysfs_readdir,
+	.close   = sysfs_close,
+	.release = sysfs_release,
+};
Index: trunk/kernel/fs/sysfs/sysfs_node.c
===================================================================
--- trunk/kernel/fs/sysfs/sysfs_node.c	(revision 1)
+++ trunk/kernel/fs/sysfs/sysfs_node.c	(revision 1)
@@ -0,0 +1,169 @@
+/*
+ * sysfs/sysfs_node.c - sysfs node related operations
+ *
+ * Copyright (c) 2008,2009,2010,2011,2012 Ghassan Almaless
+ * Copyright (c) 2011,2012 UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-kernel.
+ *
+ * ALMOS-kernel is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-kernel is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-kernel; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#include <config.h>
+#include <kmem.h>
+#include <string.h>
+#include <kdmsg.h>
+#include <vfs.h>
+#include <cpu.h>
+
+#include <sysfs.h>
+#include <sysfs-private.h>
+
+KMEM_OBJATTR_INIT(sysfs_kmem_node_init)
+{
+	attr->type   = KMEM_SYSFS_NODE;
+	attr->name   = "KCM SysFs Node";
+	attr->size   = sizeof(struct sysfs_node_s);
+	attr->aligne = 0;
+	attr->min    = CONFIG_SYSFS_NODE_MIN;
+	attr->max    = CONFIG_SYSFS_NODE_MAX;
+	attr->ctor   = NULL;
+	attr->dtor   = NULL;
+	return 0;
+}
+
+
+VFS_INIT_NODE(sysfs_init_node)
+{
+	register struct sysfs_node_s *node_info;
+	kmem_req_t req;
+  
+	node_info = inode->i_pv;
+
+	if(inode->i_pv == NULL)
+	{
+		req.type  = KMEM_SYSFS_NODE;
+		req.size  = sizeof(*node_info);
+		req.flags = AF_KERNEL;
+
+		node_info = kmem_alloc(&req);
+	}
+
+	if(node_info == NULL)
+		return ENOMEM;
+  
+	inode->i_pv = node_info;
+	return 0;
+}
+
+
+VFS_RELEASE_NODE(sysfs_release_node)
+{
+	kmem_req_t req;
+
+	req.type   = KMEM_SYSFS_NODE;
+	req.ptr    = inode->i_pv;
+	kmem_free(&req);
+	inode->i_pv = NULL;
+	return 0;
+}
+
+
+VFS_CREATE_NODE(sysfs_create_node)
+{ 
+	return ENOTSUPPORTED;
+}
+
+
+error_t sysfs_inode_create(struct vfs_dirent_s *dirent, 
+				struct vfs_inode_s *parent,
+				struct metafs_s *meta, size_t size)
+{
+	struct vfs_inode_s *inode;
+
+	inode = vfs_inode_new(dirent->d_ctx);//allocate inode
+	if(!inode) return ENOMEM;
+
+	inode->i_links  = 1;
+	inode->i_attr = dirent->d_attr;
+	((struct sysfs_node_s *)inode->i_pv)->node = meta;
+	inode->i_size = size;
+	inode->i_parent.ptr = parent;
+	inode->i_parent.cid = cpu_get_cid();
+	inode->i_parent.gc = parent->i_gc;
+	inode->i_number = vfs_inum_new(dirent->d_ctx);
+	
+	vfs_icache_add(inode);
+
+	dirent->d_inode.cid = cpu_get_cid();
+	dirent->d_inode.ptr = inode;
+
+	return 0;
+}
+
+VFS_LOOKUP_NODE(sysfs_lookup_node)
+{
+	register struct sysfs_node_s *parent_info;
+	register struct metafs_s *meta;
+	register uint_t hasChild;
+	size_t size;
+  
+	size = 0;
+	parent_info = parent->i_pv;
+  
+	sysfs_dmsg(1, "DEBUG: sysfs_lookup: %s, attr %x\n", dirent->d_name, dirent->d_attr);
+
+	if((meta = metafs_lookup(parent_info->node, dirent->d_name)) == NULL)
+		return VFS_NOT_FOUND;
+
+	hasChild = metafs_hasChild(meta);
+
+	if(hasChild && !(dirent->d_attr & VFS_DIR))
+		return EISDIR;
+  
+	if(!(hasChild) && (dirent->d_attr & VFS_DIR))
+		return ENOTDIR;
+
+	if(hasChild)
+		dirent->d_attr |= VFS_DIR;
+	else
+		size = SYSFS_BUFFER_SIZE;
+
+	sysfs_inode_create(dirent, parent, meta, size);
+  
+	return VFS_FOUND;
+}
+
+
+VFS_WRITE_NODE(sysfs_write_node)
+{
+	return 0;
+}
+
+VFS_UNLINK_NODE(sysfs_unlink_node)
+{
+	return ENOTSUPPORTED;
+}
+
+const struct vfs_inode_op_s sysfs_i_op = 
+{
+	.init    = sysfs_init_node,
+	.create  = sysfs_create_node,
+	.lookup  = sysfs_lookup_node,
+	.write   = sysfs_write_node,
+	.release = sysfs_release_node,
+	.unlink  = sysfs_unlink_node,
+	.stat    = NULL,
+	.delete  = NULL
+};
Index: trunk/kernel/kern/blkio.c
===================================================================
--- trunk/kernel/kern/blkio.c	(revision 1)
+++ trunk/kernel/kern/blkio.c	(revision 1)
@@ -0,0 +1,259 @@
+/*
+ * blkio.c - provides per-page buffers I/O
+ * 
+ * Copyright (c) 2008,2009,2010,2011,2012 Ghassan Almaless
+ * Copyright (c) 2011,2012 UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-kernel.
+ *
+ * ALMOS-kernel is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-kernel is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-kernel; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#include <cpu.h>
+#include <errno.h>
+#include <scheduler.h>
+#include <kmem.h>
+#include <thread.h>
+#include <device.h>
+#include <driver.h>
+#include <event.h>
+#include <atomic.h>
+#include <cluster.h>
+#include <page.h>
+#include <blkio.h>
+
+static EVENT_HANDLER(blkio_async)
+{
+	struct blkio_s *blkio;
+	struct blkio_s *info;
+	struct page_s *page;
+	struct thread_s *thread;
+	error_t err;
+	uint_t irq_state;
+
+	blkio = event_get_argument(event);
+	page  = blkio->b_page;
+	info  = list_head(&page->root, struct blkio_s, b_list);
+	err   = event_get_error(event);
+
+	if(err)
+	{
+		printk(WARNING, "WARNING: %s: Requested I/O is failed, blk %d\n", 
+		       __FUNCTION__, 
+		       blkio->b_dev_rq.src);
+	}
+
+	err = (err) ? 1 : 0;
+
+	spinlock_lock_noirq(&info->b_ctrl.lock, &irq_state);
+
+	info->b_ctrl.cntr ++;
+	info->b_ctrl.error = (info->b_ctrl.error) ? 1 : err;
+
+	if(info->b_ctrl.cntr == info->b_ctrl.count) 
+	{
+		thread = wakeup_one(&info->b_ctrl.wait, WAIT_ANY);
+
+#if CONFIG_BLKIO_DEBUG    
+		if(thread != NULL)
+		{
+			printk(INFO, "%s: cpu %d, wakeup tid %d on cpu %d [%u]\n",
+			       __FUNCTION__,
+			       cpu_get_id(),
+			       thread->info.order,
+			       thread_current_cpu(thread)->gid,
+			       cpu_time_stamp());
+		}
+#endif
+	}
+
+	spinlock_unlock_noirq(&info->b_ctrl.lock, irq_state);
+	return 0;
+}
+
+static void blkio_ctor(struct kcm_s *kcm, void *ptr) 
+{
+	struct blkio_s *blkio = (struct blkio_s *)ptr;
+
+	spinlock_init(&blkio->b_ctrl.lock, "BlkIO");
+	event_set_handler(&blkio->b_dev_rq.event, blkio_async);
+	event_set_priority(&blkio->b_dev_rq.event, E_BLK);
+	event_set_argument(&blkio->b_dev_rq.event, blkio);
+	wait_queue_init(&blkio->b_ctrl.wait, "BLKIO Sync");
+}
+
+KMEM_OBJATTR_INIT(blkio_kmem_init)
+{
+	attr->type = KMEM_BLKIO;
+	attr->name = "KCM BLKIO";
+	attr->size = sizeof(struct blkio_s);
+	attr->aligne = 0;
+	attr->min = CONFIG_BLKIO_MIN;
+	attr->max = CONFIG_BLKIO_MAX;
+	attr->ctor = blkio_ctor;
+	attr->dtor = NULL;
+	return 0;
+}
+
+///////////////////////////////////
+error_t blkio_init( device_t * dev,
+                    page_t   * page,
+                    uint32_t   count ) 
+{
+	kmem_req_t req;
+	struct blkio_s *blkio;
+	uint_t blkio_nr;
+
+	req.type  = KMEM_BLKIO;
+	req.size  = sizeof(*blkio);
+	req.flags = AF_KERNEL;
+  
+	slist_root_init(&page->root);
+	blkio_nr = count;
+
+#if CONFIG_BLKIO_DEBUG    
+	printk(INFO, "%s: cpu %d, count %d, pg @0x%x, index %d [%d]\n",
+	       __FUNCTION__, 
+	       cpu_get_id(),
+	       count, 
+	       page, 
+	       page->index,
+	       cpu_time_stamp());
+#endif
+
+	while(count)
+	{
+		if((blkio = kmem_alloc(&req)) == NULL) 
+		{
+			blkio_destroy(page);
+			return ENOMEM;
+		}
+    
+		blkio->b_flags = 0;
+		blkio->b_page  = page;
+		blkio->b_dev   = dev;
+
+		list_push(&page->root, &blkio->b_list);
+		count -= 1;
+	}
+
+	blkio = list_head(&page->root, struct blkio_s, b_list);
+
+	blkio->b_ctrl.count = blkio_nr;
+	blkio->b_ctrl.cntr  = 0;
+	blkio->b_ctrl.error = 0;
+
+	PAGE_SET(page, PG_BUFFER);
+	return 0;
+}  // end blkio_init()
+
+
+////////////////////////////////////
+error_t blkio_sync( page_t   * page,
+                    uint32_t   flags ) 
+{
+	slist_entry_t    * iter;
+	blkio_t          * blkio;
+	blkio_t          * info;
+	device_request_t * handler;
+	error_t            err;
+	uint32_t           irq_state;
+	uint32_t           cntr;
+
+	info = list_head(&page->root, struct blkio_s, b_list);
+	handler = (flags & BLKIO_RD) ? info->b_dev->op.dev.read : info->b_dev->op.dev.write;
+	cntr =  0;
+	err =  0;
+
+	list_foreach(&page->root, iter) 
+	{
+		blkio = list_element(iter, struct blkio_s, b_list);
+
+		if(blkio->b_flags & BLKIO_INIT)
+		{
+			blkio->b_flags &= ~BLKIO_INIT;
+			continue;
+		}
+
+		blkio->b_dev_rq.flags = DEV_RQ_NOBLOCK;
+
+#if CONFIG_BLKIO_DEBUG  
+		printk(INFO, "%s: cpu %d, Submitting blkio #%d, src %d, dst %x [%d]\n",
+		       __FUNCTION__, 
+		       cpu_get_id(),
+		       cntr, 
+		       blkio->b_dev_rq.src, 
+		       blkio->b_dev_rq.dst, 
+		       cpu_time_stamp());
+#endif
+
+		err = handler(blkio->b_dev, &blkio->b_dev_rq);
+    
+		if(err < 0) 
+		{
+			err = EIO;
+			break;
+		}
+
+		cntr ++;
+	}
+
+	if(flags & BLKIO_SYNC) 
+	{
+		spinlock_lock_noirq(&info->b_ctrl.lock, &irq_state);
+    
+		info->b_ctrl.cntr += (info->b_ctrl.count - cntr);
+
+		if(info->b_ctrl.cntr < info->b_ctrl.count) 
+		{
+			wait_on(&info->b_ctrl.wait, WAIT_ANY);
+			spinlock_unlock_noirq(&info->b_ctrl.lock, irq_state);
+			sched_sleep(CURRENT_THREAD);
+
+#if CONFIG_BLKIO_DEBUG
+			printk(INFO, "%s: cpu %d, tid %d, blkio ended, err %d\n",
+			       __FUNCTION__, 
+			       cpu_get_id(), 
+			       CURRENT_THREAD->info.order, 
+			       info->b_ctrl.error);
+#endif
+
+		}
+		else
+			spinlock_unlock_noirq(&info->b_ctrl.lock, irq_state);
+
+		return (info->b_ctrl.error) ? EIO : 0;
+	}
+
+	return err;
+}
+
+//////////////////////////////////////////
+error_t blkio_destroy(struct page_s *page) 
+{
+	kmem_req_t req;
+	struct slist_entry *iter;
+
+	req.type = KMEM_BLKIO;
+
+	list_foreach(&page->root, iter) 
+	{
+		req.ptr = list_element(iter, struct blkio_s, b_list);
+		kmem_free(&req);
+	}
+
+	page->private = 0;
+	PAGE_CLEAR(page, PG_BUFFER);
+	return 0;
+}
Index: trunk/kernel/kern/blkio.h
===================================================================
--- trunk/kernel/kern/blkio.h	(revision 1)
+++ trunk/kernel/kern/blkio.h	(revision 1)
@@ -0,0 +1,100 @@
+/*
+ * kern/blkio.c - Per-page buffers I/O interface
+ * 
+ * Copyright (c) 2008,2009,2010,2011,2012 Ghassan Almaless
+ * Copyright (c) 2011,2012 UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-kernel.
+ *
+ * ALMOS-kernel is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-kernel is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-kernel; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#ifndef BLKIO_H_
+#define BLKIO_H_
+
+#include <list.h>
+
+#define BLKIO_RD        0x01
+#define BLKIO_SYNC      0x02
+
+#define BLKIO_INIT      0x01
+
+#include <page.h>
+#include <device.h>
+#include <list.h>
+
+/******************************************************************************************
+ *****************************************************************************************/
+typedef struct blkio_s 
+{
+	uint32_t            b_flags;        // BLKIO_INIT
+
+	struct
+	{
+		spinlock_t		    lock;		
+		uint16_t            count;	
+		uint16_t            cntr;	        
+		error_t             error;	
+		struct wait_queue_s wait;
+
+	}                     b_ctrl;         // Only used in head-blkio
+
+	dev_request_t       b_dev_rq;	// request for the block device
+	page_t         *    b_page;		// buffer page descriptor
+	device_t       *    b_dev;		// block device
+	slist_entry_t       b_list;	    // next buffer in this page
+	void           *	b_private;	// data for the I/O completion method
+}
+blkio_t;
+
+/**
+ * Macro to set a blkio to be skiped while first sync  
+ * 
+ * @b          pointer to blkio
+ */
+#define blkio_set_initial(b)			\
+	do{(b)->b_flags |= BLKIO_INIT;}while(0)
+
+KMEM_OBJATTR_INIT(blkio_kmem_init);
+
+/******************************************************************************************
+ * Initializes the blkio structure.
+ ******************************************************************************************
+ * @ dev    : pointer on block device.
+ * @ page   : buffer page to get blkio structures initialized
+ * @ count  : number of blocks in the page
+ * @ return	error code, 0 if OK
+ *****************************************************************************************/
+error_t blkio_init( device_t * dev,
+                    page_t   * page,
+                    uint32_t   count );
+
+/**
+ * Synchronizes all the buffers in a buffer page.
+ *
+ * @page	buffer page to be synced with the disk
+ * @flags	blkio flags
+ * @return	error code, 0 if OK
+ */
+error_t blkio_sync(struct page_s *page, uint_t flags);
+
+/**
+ * Destroys the blkio structures for a buffer page.
+ *
+ * @page	buffer page to have its blkio structures destroyed
+ * @return	error code, 0 if OK
+ */
+error_t blkio_destroy(struct page_s *page);
+
+#endif /* BLKIO_H_ */
